<style>
.scan_ct{
  margin: 20px;
}
.file_ct{
  position: relative;
  height: 200px;
  background-color: #eee;
}
.upload_action{
  position: absolute;
  width: 100%;
  height: 100%;
  left: 0px;
  top: 0px;
  opacity: 0;
  z-index: 1;
}
.file_des_ct{
  position: absolute;
  left: 0px;
  top: 0px;
  width: 100%;
  height: 100%;
  display: flex;
  align-items: center;
  justify-content: center;
  color: #717171;
  font-size: 16px;
}
.vedio_ct{
  margin: 20px;
}

@keyframes rotate {
  0% {
    transform: rotate(0deg)
  }
  /*50% {transform: rotate(180) }*/
  100% {
    transform: rotate(360deg)
  }
}

.load_area{
  display: flex;
  justify-content: center;
  align-items: center;
  width: 136px;
  flex-wrap: wrap;
}
.load_area .load_circle{
  width: 30px;
  height: 30px;
  border-radius: 100px;
  border: 2px solid #009688;
  border-top: 2px solid rgba(0, 0, 0, 0);
  animation: rotate 1s linear infinite; 
}
.load_area_text{
  margin-top: 30px;
}
.top_info_mask{
  display: flex;
  justify-content: center;
  position: fixed;
  z-index: 11;
  width: 100%;
  top: 0px;
}
.top_info{
  box-shadow: 0px 0px 20px #f1f1f1;
  font-size: 12px;
  padding: 7px 29px;
  background-color: #ffffff;
  border-radius: 4px;
  margin-top: 20px;
  color: #009688;
}
.scan_record{
  margin: 20px;
  font-weight: 300;
}
.scan_tab{
  display: flex;
  justify-content: center;
  align-items: center;
  background: #f1f1f1;
  border-radius: 2px;
  overflow: hidden;
}
.scan_tab .scan_tab_item{
  display: flex;
  justify-content: center;
  align-items: center;
  text-align: center;
  width: 50%;
  height: 30px;
  color: #505050;
}
.scan_tab .scan_tab_item_selected{
  background-color: #4CAF50;
  color: #fff;
  box-shadow: 0px 0px 10px #b1b1b1;
  border-radius: 4px;
}
.qr_sended_list_item{
  line-height: 40px;
  border-bottom: 1px solid #eee;
}
.qr_sended_list_items_ct{
  margin-top: 20px;
}
.no_data{
  height: 60px;
  display: flex;
  align-items: center;
  justify-content: center;
}
</style>
<template>
  <div>

    <div class="top_info_mask" v-if="successfull">
      <div class="top_info">
        存储成功
      </div>
    </div>
    
    <div class="vedio_ct">
      <!-- <QrcodeStream @decode="onDecode"></QrcodeStream> -->
      <StreamBarcodeReader
        @decode="onDecode"
    ></StreamBarcodeReader>
    </div>

    <div class="scan_ct">
      <div class="file_ct">
        <!-- <input class="upload_action" type="file"/> -->
        <div class="file_des_ct" v-if="!on_load_send_data">请将条形码或二维码，放入摄像头前</div>

        <div class="file_des_ct" v-if="on_load_send_data">
          <div class="load_area">
            <div class="load_circle"></div>
            <div class="load_area_text">正在发送到服务端</div>
            <div>还剩下{{ this.qr_list.length }} 等待发送</div>
          </div>
        </div>

      </div>
      <!-- <canvas id="canvas" hidden></canvas> -->
    </div>

    <div class="scan_record">
      <div class="scan_tab">
        <div class="scan_tab_item" v-bind:class="{'scan_tab_item_selected': item.is_selected}" v-for="item in tabs.tab_items" @click="exchange_tab(item)">
          {{ item.text }}
        </div>
        <!-- <div class="scan_tab_item">正在等待</div> -->
      </div>


      <div class="qr_sended_list_items_ct">
        <!-- {{ tabs.selected_list }} -->
        <div v-if="!tabs.selected_list.length">
          <div class=" no_data">当前无记录</div>
        </div>

        <div class="qr_sended_list_item" v-for="row, index in tabs.selected_list">
          {{ row }}
        </div>
      </div>
    </div>

  </div>
</template>
<script>
import { wait_time } from '../modules/utils'
import { add_code_to_chain } from '../service'
import { QrcodeStream, QrcodeDropZone, QrcodeCapture } from 'vue-qrcode-reader'
import { StreamBarcodeReader } from "vue-barcode-reader";

export default {
  data () {
    return {
      video: null,
      on_load_send_data: false,
      qr_list: [],
      qr_sended_list: [],
      successfull: false,
      tabs: {
        selected_list: [],
        tab_items: [
          {
            'text': '已扫码历史',
            'value': 'qr_sended_list',
            'is_selected': true
          },
          {
            'text': '正在等待',
            'value': 'qr_list',
            'is_selected': false
          }
        ]
      }
    }
  },

  mounted () {
    // this.create_vedio();
    this.exchange_tab(tabs.tab_items[0]);
  },

  components: {
    QrcodeStream,
    QrcodeDropZone,
    QrcodeCapture,
    StreamBarcodeReader
  },

  methods: {
    async onDecode (decodedString) {
      // alert(decodedString);
      this.qr_list.push(decodedString);
      this.send();
    },

    async send () {
      if(this.on_load_send_data) return ;
      this.on_load_send_data = true;
      let decodedString = this.qr_list.pop();
      
      if(decodedString){
        console.log(`正在发送到服务端 ${decodedString}`);
        await wait_time(3);
        console.log(`------>  发送成功`);
        this.qr_sended_list.push(decodedString);
      }
      this.on_load_send_data = false;

      if(this.qr_list.length){
        this.send();
      }

    },

    async exchange_tab (tab_item) {
      this.tabs.selected_list = this[tab_item.value];
      this.tabs.tab_items.forEach(row => {
        if(row.value != tab_item.value){
          row.is_selected = false;
        }else{
          row.is_selected = true;
        }
      })
    },

    async create_vedio () {
      requestAnimationFrame(this.tick);
      await wait_time(3);
      let video = this.$refs.vedio;
      console.log( video );
      let _this = this;
      navigator.mediaDevices.getUserMedia({ video: { facingMode: "environment" } }).then(stream => {
        video.srcObject = stream;
        video.setAttribute("playsinline", true); 
        video.play();
        requestAnimationFrame(this.tick);
      });
    },

    drawLine(begin, end, color) {
      var canvasElement = document.getElementById("canvas");
      var canvas = canvasElement.getContext("2d");

      canvas.beginPath();
      canvas.moveTo(begin.x, begin.y);
      canvas.lineTo(end.x, end.y);
      canvas.lineWidth = 4;
      canvas.strokeStyle = color;
      canvas.stroke();
    },

    tick() {
      let video = this.$refs.vedio;
      var canvasElement = document.getElementById("canvas");
      var canvas = canvasElement.getContext("2d");
      // loadingMessage.innerText = "⌛ Loading video..."
      if (video.readyState === video.HAVE_ENOUGH_DATA) {
        // loadingMessage.hidden = true;
        canvasElement.hidden = false;
        outputContainer.hidden = false;

        canvasElement.height = video.videoHeight;
        canvasElement.width = video.videoWidth;
        canvas.drawImage(video, 0, 0, canvasElement.width, canvasElement.height);
        var imageData = canvas.getImageData(0, 0, canvasElement.width, canvasElement.height);
        
        var code = jsQR(imageData.data, imageData.width, imageData.height, {
          inversionAttempts: "dontInvert",
        });
        if (code) {
          drawLine(code.location.topLeftCorner, code.location.topRightCorner, "#FF3B58");
          drawLine(code.location.topRightCorner, code.location.bottomRightCorner, "#FF3B58");
          drawLine(code.location.bottomRightCorner, code.location.bottomLeftCorner, "#FF3B58");
          drawLine(code.location.bottomLeftCorner, code.location.topLeftCorner, "#FF3B58");
          outputMessage.hidden = true;
          outputData.parentElement.hidden = false;
          outputData.innerText = code.data;
        } else {
          outputMessage.hidden = false;
          outputData.parentElement.hidden = true;
        }
      }
    }
  }
}
</script>